; Basically all the comments here are added by Simon Brattel, I'm sure Martin would have commented more
; if he'd had room.

; This source was written by Martin Horsley in 1983. The format is hideous because he did using Zeus
; on a Spectrum and was working within the constraints of that environment. I couldn't have done that...
; I've extracted a lot of duplicated code out into macros, I'm sorry if this confuses anyone but it might
; make it easier to see what's going on in the main drawing routine.

MaxForwardSpeed         equ 94
MaxBackwardSpeed        equ 32
MaxAngularVelocity      equ 88

Lamp1                   EQU  #5939
Lamp2                   EQU  #5959
Lamp3                   EQU  #5979
Lamp4                   EQU  #5999
Lamp5                   EQU  #59B9
Lmp12a                  EQU  4
Lmp12b                  EQU  #46
Lmp34a                  EQU  3
Lmp34b                  EQU  5
Lmp34c                  EQU  #82
Lmp5a                   EQU  #44
Lmp5b                   EQU  #46
Lmp5c                   EQU  #42
ScDel                   EQU  2
SlrDel                  EQU  1
SudDel                  EQU  2
DVDel                   EQU  2
EnDDel                  EQU  2
nRotat                  EQU  201

; Interrupt stuff

iPage                   equ  #FD00
iPgH                    EQU  #FD
iAddrB                  EQU  #FE
iAddr                   EQU  #FEFE

; Can start at $5B00 straight above the graphics

                        org $5B00

; And now the code.

Start                   di
                        ld sp,iPage

                        CALL MakeE
                        CALL BuildDiv3table
                        CALL InDisp
                        CALL InitStars
                        CALL PutPly
                        CALL InNME
                        CALL EInts

GLoop                   CALL ReadKeys
                        CALL PlyMov
                        CALL ShiSc
                        CALL RegEn
                        CALL MvNME
                        CALL MoveStar

                        LD   A,(PORT)
                        XOR  #10
                        LD   (PORT),A

                        jr GLoop

GFin                    CALL DInts
                        RET

InDisp                  CALL ClrScr

                        LD   A,7
                        CALL Attrib

                        LD   HL,#D000
                        LD   DE,#D001
                        LD   BC,#0FFF
                        LD   (HL),0
                        LDIR

                        INC  C                  ; 1
                        LD   A,C

                        LD   (disav),A
                        LD   (disfv),BC
                        LD   (PORT),A
                        LD   (scdel),A
                        LD   (slrdel),A
                        LD   (suddel),A
                        LD   (enddel),A
                        LD   (dvdel),A
                        LD   (kncctr),A
                        LD   (nmectr),A

                        CALL DrawScreenBorder
                        CALL EnFilt
                        CALL VelInd
                        CALL Scaner
                        CALL Lights
                        CALL ShCAut
                        CALL DisVel
                        CALL ScWord

                        LD   A,2
                        LD   (shcomm),A

                        CALL LScanr

                        LD   A,235
                        LD   (energy),A

                        CALL EnDisp

                        RET

; Drive the shields

ShiSc                   LD   A,(shstat)
                        CP   2
                        JP   Z,Knackd

                        LD   C,A

                        LD   A,(shcomm)
                        CP   1
                        JR   C,ShiSOf

                        JR   Z,ShiSOn

ShiSAu                  LD   A,(condition)
                        CP   2
                        JR   NC,ShiSOn

ShiSOf                  LD   A,C
                        OR   A
                        RET  Z

                        XOR  A
                        LD   (shstat),A

                        CALL LScanr
                        CALL Scaner

                        LD   A,Lmp34b
                        LD   (Lamp3),A

                        LD   A,Lmp34a
                        LD   (Lamp4),A

                        LD   IX,tNME
                        LD   B,nEnemy
                        LD   DE,lEnemy

ShSOf1                  EXX

                        LD   A,(IX+dShapeAndAlive)
                        OR   A
                        JR   Z,ShSOf2

                        CALL SRSBit

ShSOf2                  EXX
                        ADD  IX,DE
                        DJNZ ShSOf1

                        CALL LRSCpy
                        RET

ShiSOn                  LD   A,C
                        CP   1
                        JR   Z,ShiSFl

                        LD   A,1
                        LD   (shstat),A

                        CALL Shield

                        CALL Scaner

                        LD   A,Lmp34a
                        LD   (Lamp3),A

                        LD   A,Lmp34b
                        LD   (Lamp4),A

                        LD   A,40
                        LD   (shctr),A
                        RET

ShiSFl                  LD   HL,shctr
                        DEC  (HL)
                        RET  NZ

                        LD   (HL),15
                        JP   ShFlsh

RegEn                   LD   A,(energy)
                        CP   235
                        RET  Z
                        INC  A
                        LD   (energy),A
                        RET

ReadKeys                LD   BC,#F7FE
                        IN   A,(C)
                        LD   (k1),A
                        RRA
                        LD   (k2),A
                        RRA
                        LD   (k3),A
                        RRA
                        LD   (k4),A
                        LD   B,#FE
                        IN   A,(C)
                        RRA
                        LD   (kZ),A
                        RRA
                        LD   (kX),A
                        LD   B,#7F
                        IN   A,(C)
                        LD   (kSp),A
                        RRA
                        RRA
                        LD   (kM),A
                        RRA
                        LD   (kN),A
                        RRA
                        LD   (kB),A
                        LD   B,#FD
                        IN   A,(C)
                        CPL
                        AND  #1F
                        LD   (kA),A
                        RRCA
                        LD   (kS),A
                        RRCA
                        LD   (kD),A
                        RRCA
                        LD   (kF),A
                        RRCA
                        LD   (kG),A
                        LD   B,#DF
                        IN   A,(C)
                        CPL
                        AND  #1F
                        LD   (kP),A
                        RRCA
                        LD   (kO),A
                        LD   B,#BF
                        IN   A,(C)
                        CPL
                        AND  #1F
                        LD   (kEnt),A
                        RRCA
                        LD   (kL),A
                        RET

SRScan                  LD   DE,(IX+dX)
                        CALL Div3DE

                        SRA  D
                        RR   E

                        SRA  D
                        RR   E

                        SRA  D
                        RR   E

                        LD   HL,20
                        ADD  HL,DE

                        LD   A,H
                        OR   A
                        JR   NZ,SRSq

                        LD   A,L
                        CP   40
                        JR   NC,SRSq

                        LD   (IX+dScaledX),A

                        LD   DE,(IX+dY)
                        CALL Div3DE

                        SRA  D
                        RR   E

                        SRA  D
                        RR   E

                        SRA  D
                        RR   E

                        LD   HL,20
                        ADD  HL,DE

                        LD   A,H
                        OR   A
                        JR   NZ,SRSq

                        LD   A,L
                        CP   40
                        JR   NC,SRSq

                        LD   (IX+dScaledY),A
                        RET

SRSq                    LD   (IX+dScaledX),#80
                        LD   (IX+dScaledY),#80
                        RET

SRSBit                  LD   E,(IX+dScaledX)
                        LD   D,(IX+dScaledY)
                        LD   A,E
                        OR   D
                        CP   #80
                        RET  Z

                        LD   A,E
                        ADD  A,7
                        LD   E,A

                        AND  7

                        ld   L,a
                        LD   H,high Bits

                        LD   C,(HL)

                        LD   A,E
                        RRA
                        RRA
                        RRA
                        AND  7
                        ADD  A,#1A
                        LD   E,A

                        LD   A,D
                        ADD  A,71
                        LD   L,A

                        LD   H,high ScreenTable
                        LD   A,E
                        ADD  A,(HL)
                        INC  H
                        LD   H,(HL)
                        LD   L,A

                        LD   A,C
                        RRC  C
                        JR   C,SRSB2

                        OR   C
                        LD   C,A
                        XOR  (HL)
                        OR   1
                        LD   (HL),A
                        INC  H
                        LD   A,H
                        AND  7
                        JR   NZ,SRSB1

                        DEC  H
                        LD   (HL),#FF
                        LD   A,H
                        SUB  7
                        LD   H,A

                        LD   A,L
                        ADD  A,32
                        LD   L,A

SRSB1                   CP   7
                        RET  Z

                        LD   A,C
                        XOR  (HL)
                        OR   1
                        LD   (HL),A

                        RET

SRSB2                   INC  L
                        LD   A,C
                        XOR  (HL)
                        LD   (HL),A

                        INC  H
                        LD   A,H
                        AND  7
                        JR   NZ,SRSB3

                        DEC  H
                        LD   (HL),#FF

                        LD   A,H
                        SUB  7
                        LD   H,A

                        LD   A,L
                        ADD  A,32
                        LD   L,A

SRSB3                   CP   7
                        RET  Z

                        LD   A,C
                        XOR  (HL)
                        LD   (HL),A
                        RET

LRScan                  LD   DE,(IX+dX)
                        CALL Div3DE
                        LD   A,D
                        RL   E
                        RLA
                        RL   E
                        RLA
                        RL   E
                        ADC  A,24
                        LD   B,A
                        AND  7
                        LD   HL,Bits
                        LD   E,A
                        LD   D,0
                        ADD  HL,DE
                        LD   C,(HL)
                        PUSH BC
                        LD   DE,(IX+dY)
                        CALL Div3DE
                        LD   A,D
                        RL   E
                        RLA
                        RL   E
                        RLA
                        RL   E
                        ADC  A,22
                        LD   E,A
                        ADD  A,A
                        ADD  A,E
                        LD   L,A
                        LD   H,0
                        LD   DE,lrsbuf
                        ADD  HL,HL
                        ADD  HL,DE
                        POP  BC
                        LD   D,0
                        LD   A,B
                        RRA
                        RRA
                        RRA
                        AND  7
                        LD   E,A
                        ADD  HL,DE
                        LD   A,(HL)
                        OR   C
                        LD   (HL),A
                        RET

LRSCpy                  LD   HL,lrsbuf
                        LD   DE,#411A
                        LD   B,7
                        LD   C,46

LRSCp1                  loop 5
                          LD   A,(HL)
                          LD   (DE),A
                          INC  HL
                          INC  E
                          lend

                        LD   A,(HL)
                        LD   (DE),A
                        INC  HL

                        LD   A,E
                        AND  #FA
                        LD   E,A

                        INC  D
                        DJNZ LRSCp2

                        LD   B,8

                        LD   A,E
                        ADD  A,32
                        LD   E,A

                        LD   A,D
                        SUB  8
                        LD   D,A

LRSCp2                  DEC  C
                        JR   NZ,LRSCp1

                        RET

LRSClr                  LD   HL,lrsbuf
                        LD   B,46
                        LD   C,0
                        LD   DE,#8001
LRSCl1                  LD   (HL),D
                        INC  HL
                        LD   (HL),C
                        INC  HL
                        LD   (HL),C
                        INC  HL
                        LD   (HL),C
                        INC  HL
                        LD   (HL),C
                        INC  HL
                        LD   (HL),E
                        INC  HL
                        DJNZ LRSCl1

                        LD   HL,lrsbuf+135
                        LD   (HL),D
                        RET

RInts                   CALL ChngeV
                        CALL DisVel
                        CALL EnDisp
                        CALL ScDisp
                        CALL ScLfRt
                        CALL ScUpDn
                        RET

EInts                   DI
                        LD   H,iPgH
                        LD   BC,#100
                        LD   L,C
                        LD   E,B
                        LD   D,H
                        LD   (HL),iAddrB
                        LDIR
                        LD   HL,Intrpt
                        LD   DE,iAddr
                        LD   BC,iLenth
                        LDIR
                        LD   A,iPgH
                        LD   I,A
                        IM   2
                        EI
                        RET

; This isn't executed here but copied to the top of memory

Intrpt                  PUSH BC,DE,HL,AF
                        EXX
                        EX AF,AF'
                        PUSH BC,DE,HL,AF
                        CALL RInts
                        POP  AF,HL,DE,BC
                        EX   AF,AF'
                        EXX
                        POP  AF,HL,DE,BC
                        EI
                        RETI
iLenth                  EQU  $-Intrpt

DInts                   DI
                        IM   0
                        LD   A,#3A
                        LD   I,A
                        RET

; Random routines from Halls

RandRange               or a                            ;
                        ret z                           ;

                        push hl                         ;
                        push de                         ;
                        push bc                         ;

                        ld c,a                          ;
                        call RandOnly_A                 ;
                        ld l,a                          ;
                        xor a                           ;
                        ld b,8                          ;
RandR1                  rl l                            ;
                        rla                             ;
                        cp c                            ;
                        jr c RandR2                     ;

                        sub c                           ;
RandR2                  djnz RandR1                     ;

                        pop bc                          ;
                        pop de                          ;
                        pop hl                          ;
                        ret                             ;

Rand                    call Rand1                      ;

                        ld a,(Seed)                     ;
                        ret                             ;

RandOnly_A              push hl                         ; Save
                        push de                         ;
                        push bc                         ;

                        call Rand1                      ;

                        ld a,(Seed)                     ;

                        pop bc                          ;
                        pop de                          ;
                        pop hl                          ;
                        ret                             ; Done

RandOnly_HL             push af                         ; Save
                        push de                         ;
                        push bc                         ;

                        call Rand1                      ;

                        ld hl,(Seed)                    ;

                        pop bc                          ;
                        pop de                          ;
                        pop af                          ;
                        ret                             ; Done

Rand1                   ld hl,(Seed+2)                  ;
                        rl l                            ;
                        rl h                            ;
                        rl l                            ;
                        rl h                            ;
                        ld c,h                          ;
                        ld a,(Seed)                     ;
                        rla                             ;
                        ld b,a                          ;
                        ld de,(Seed+1)                  ;
                        rl e                            ;
                        rl d                            ;
                        res 7,d                         ;
                        ld hl,(Seed)                    ;
                        add hl,bc                       ;
                        ld (Seed),hl                    ;
                        ld hl,(Seed+2)                  ;
                        adc hl,de                       ;
                        res 7,h                         ;
                        ld (Seed+2),hl                  ;
                        ret m                           ;

                        ld hl,Seed                      ;
Rnd1                    inc (hl)                        ;
                        ret nz                          ;
                        inc hl                          ;
                        jp Rnd1                         ;

                        include "player.inc"            ;
                        include "enemy.inc"             ;
                        include "stars.inc"             ;
                        include "maths.inc"             ;
                        include "graphics.inc"          ;
                        include "line.inc"              ;
                        include "drawsprite.inc"        ;
                        include "data.inc"              ;

SaveTop                 equ *

; Nothing needs to be saved above this

; I want to make sure this doesn't cross a page boundary so I can use 8-bit incs for speed when accessing it. It shouldn't here
tInDef                  DEFS 6
                        if high $ <> high tInDef
                          zeuserror "tInDef can't straddle a page boundary! Move it!"
                        endif

                        align $100
ScreenTable             ds $200
Div3Table               ds $200

kZ                      DEFS 1
kX                      DEFS 1
kN                      DEFS 1
kM                      DEFS 1
kSp                     DEFS 1
k1                      DEFS 1
k2                      DEFS 1
k3                      DEFS 1
k4                      DEFS 1
kB                      DEFS 1
kS                      DEFS 1
kD                      DEFS 1
kA                      DEFS 1
kO                      DEFS 1
kP                      DEFS 1
kL                      DEFS 1
kEnt                    DEFS 1
kF                      DEFS 1
kG                      DEFS 1
                        DEFS 10                         ;SpareKeys
angle                   DEFS 1
angsig                  DEFS 1
fwdmov                  DEFS 2
velang                  DEFS 1
velfwd                  DEFS 2
dmpang                  DEFS 1
dmpfwd                  DEFS 1
disaad                  DEFS 2
disamk                  DEFS 2
disfa1                  DEFS 2
disfa2                  DEFS 2
shstat                  DEFS 1
shcomm                  DEFS 1
condition               DEFS 1
shctr                   DEFS 1
energy                  DEFS 1
endisp                  DEFS 1
disav                   DEFS 1
disfv                   DEFS 2
score                   DEFS 2
scodis                  DEFS 2
scdig1                  DEFS 1
scdig2                  DEFS 1
scdig3                  DEFS 1
scdig4                  DEFS 1
scctr                   DEFS 1
scdel                   DEFS 1
slrdel                  DEFS 1
slrflg                  DEFS 1
slrptr                  DEFS 2
slrfre                  DEFS 1
slrctr                  DEFS 1
slrbuf                  DEFS 7
suddel                  DEFS 1
sudfre                  DEFS 1
sudctr                  DEFS 1
sudrct                  DEFS 1
sudptr                  DEFS 2
sudbuf                  DEFS 56
dvdel                   DEFS 1
enddel                  DEFS 1
kncctr                  DEFS 1
kncptr                  DEFS 1
lrsbuf                  DEFS 276
nmectr                  DEFS 1
tStars                  DEFS lStar * nStars
tNME                    DEFS lEnemy * nEnemy
PORT                    DEFB 1
Seed                    ds 4                            ;

; Save the result as a sxz file for emulators

        if zeusver < 29
                        zeusprint "You might need a newer version of Zeus to assemble this correctly."
                        zeusprint "If it puts this output somewhere strange give it a full path to the files"
                        zeusprint ""
        endif

;	zeusprinthex SaveTop

                        output_szx "galactic.szx",$0000,Start      ; The szx file

